import Vue, { VueConstructor } from 'vue';
import { SetupFunction, SetupContext } from './ts-api';
import { Wrapper } from './wrappers';
declare module 'vue/types/options' {
    interface ComponentOptions<V extends Vue> {
        setup?: SetupFunction<{}, {}>;
    }
}
declare const plugin: {
    install: (Vue: VueConstructor<Vue>) => void;
};
export { default as createElement } from './createElement';
export { plugin, Wrapper, SetupContext };
export { set } from './reactivity';
export { createComponent, PropType } from './ts-api';
export * from './functions/state';
export * from './functions/lifecycle';
export * from './functions/watch';
export * from './functions/computed';
export * from './functions/inject';
